#include "chdecl.h"
void CH_findfile_proglit(current, sched, cop)
#define ARGUMENTS 5
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb2;
    case 2: goto c3;
    case 3: goto c28;
    case 4: goto c43;
    case 5: goto c62;
    case 6: goto c73;
    case 7: goto c81;
    case 8: goto c90;
    case 9: goto c91;
    case 10: goto c94;
    case 11: goto c108;
    case 12: goto c119;
    case 13: goto c122;
    case 14: goto c130;
    case 15: goto c140;
    case 16: goto c147;
    case 17: goto c166;
    case 18: goto c175;
    case 19: goto c181;
    case 20: goto c182;
    case 21: goto c185;
    case 22: goto c186;
    case 23: goto c189;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
/* block , 1 */
  if((ch_returncode = che_block(QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb2:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c3:
/* size 4 3.0 */
  REF(4).value.integer = REF(3)DOT(0).value.table->size;
  REF(4).tsdr = & dr_integer;
/* notequal . 4 =(0) , 10 */
  if ( REF(4).value.integer != 0 ) goto c10;
/* return_exception 3 , 2 */
  if (ch_caller = do_return(REF(3).value)) {
    raise_user(QUAL(2),ch_caller); 
    sched->wakeup_proc(sched,ch_caller);}
  else rem_return_exception(DEF(3),QUAL(2));
  REF(3).tsdr = & dr_bottom;
/* exit , 3 */
  ch_e = handler_type__exit; ch_val = QUAL(3); goto ch_exception;
c10:
/* new_table 3.2 , 4 */
  if ((ch_returncode = che_new_table(DEF(3)DOT(2),QUAL(4),sched)) != Normal) 
     goto ch_raise_exception;
/* initget 5 3.0 , 0,0 */
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(5),DEF(3)DOT(0),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
/* get_or_err 5 3.0 */
  if ((ch_returncode = get_selected_object(DEF(5),DEF(3)DOT(0)
    ,sched)) != Normal) goto ch_raise_exception;
/* copy 6 5 */
  REF(6) = REF(5);
/* endget 5 3.0 */
  end_selector(DEF(5),DEF(3)DOT(0),sched,GET);
/* notequal . 6 =(47) , 20 */
  if ( REF(6).value.ord_enum != 47 ) goto c20;
/* copy 7 3.0 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(0).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).value = ch_val;
  REF(7).tsdr = & dr_table;
/* branch , 22 */
   goto c22;
c20:
/* concat 7 3.1 3.0 */
  if ((ch_returncode = che_concat(DEF(7),DEF(3)DOT(1),DEF(3)DOT(0)
    ,sched)) != Normal) goto ch_raise_exception;
c22:
/* ilit 8 , 0 */
  REF(8).value.integer = 0;
  REF(8).tsdr = & dr_integer;
/* boolean 9 , TRUE */
  REF(9).value.boolean = TRUE;
  REF(9).tsdr = & dr_boolean;
/* copy 10 7 */
  if((ch_returncode = cp_table(& ch_val, REF(7).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(10).tsdr)->finalize)(REF(10).value,F_DISCARD,sched);
  REF(10).value = ch_val;
  REF(10).tsdr = & dr_table;
/* initget 11 10 , 0,0 */
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(11),DEF(10),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c28:
/* get_or_goto 11 10 , 122 */
  if ((ch_returncode = get_selected_object(DEF(11),DEF(10),sched)) != Normal)
     goto c122;
/* notequal . 11 =(47) , 94 */
  if ( REF(11).value.ord_enum != 47 ) goto c94;
/* notequal . 8 =(0) , 36 */
  if ( REF(8).value.integer != 0 ) goto c36;
/* branch , 91 */
   goto c91;
c36:
/* noop */
  
/* notequal . 8 =(2) , 73 */
  if ( REF(8).value.integer != 2 ) goto c73;
/* ilit 12 , -1 */
  REF(12).value.integer = -1;
  REF(12).tsdr = & dr_integer;
/* copy 13 3.2 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(2).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(13).tsdr)->finalize)(REF(13).value,F_DISCARD,sched);
  REF(13).value = ch_val;
  REF(13).tsdr = & dr_table;
/* initget 14 13 , 0,0 */
  (*(REF(14).tsdr)->finalize)(REF(14).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(14),DEF(13),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c43:
/* get_or_goto 14 13 , 50 */
  if ((ch_returncode = get_selected_object(DEF(14),DEF(13),sched)) != Normal)
     goto c50;
/* notequal . 14 =(47) , 43 */
  if ( REF(14).value.ord_enum != 47 ) goto c43;
/* position 12 14 */
  ch_frame = get_selector_frame(DEF(14),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(12).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(12).tsdr = &dr_integer;
/* branch , 43 */
   goto c43;
c50:
/* endget 14 13 */
  end_selector(DEF(14),DEF(13),sched,GET);
/* discard 13 */
  (*(REF(13).tsdr)->finalize)(REF(13).value,F_DISCARD,sched);
  REF(13).tsdr = & dr_bottom;
/* ige . 12 =(0) , 59 */
  if ( REF(12).value.integer >= 0 ) goto c59;
/* discard 3.2 */
  (*(REF(3)DOT(2).tsdr)->finalize)(REF(3)DOT(2).value,F_DISCARD,sched);
  REF(3)DOT(2).tsdr = & dr_bottom;
/* return_exception 3 , 2 */
  if (ch_caller = do_return(REF(3).value)) {
    raise_user(QUAL(2),ch_caller); 
    sched->wakeup_proc(sched,ch_caller);}
  else rem_return_exception(DEF(3),QUAL(2));
  REF(3).tsdr = & dr_bottom;
/* exit , 3 */
  ch_e = handler_type__exit; ch_val = QUAL(3); goto ch_exception;
c59:
/* new_table 15 , 4 */
  if ((ch_returncode = che_new_table(DEF(15),QUAL(4),sched)) != Normal) 
     goto ch_raise_exception;
/* privatize 3.2 */
  if (REF(3)DOT(2).value.table->refcount != 1)
    if ((ch_returncode = doCopyOnWrite(DEF(3)DOT(2))) != Normal)
       goto ch_raise_exception;
/* initget 16 3.2 , 0,0 */
  (*(REF(16).tsdr)->finalize)(REF(16).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(16),DEF(3)DOT(2),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c62:
/* get_or_goto 16 3.2 , 69 */
  if ((ch_returncode = get_selected_object(DEF(16),DEF(3)DOT(2)
    ,sched)) != Normal) goto c69;
/* position 17 16 */
  ch_frame = get_selector_frame(DEF(16),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(17).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(17).tsdr = &dr_integer;
/* ilt . 17 12 , 62 */
  if ( REF(17).value.integer < REF(12).value.integer ) goto c62;
/* remove 18 16 3.2 */
  if ((ch_returncode = che_remove(DEF(18),DEF(16),DEF(3)DOT(2)
    ,sched)) != Normal) goto ch_raise_exception;
/* insert 15 18 */
  if ((ch_returncode = insertfunc(DEF(15),DEF(18),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 62 */
   goto c62;
c69:
/* endget 16 3.2 */
  end_selector(DEF(16),DEF(3)DOT(2),sched,GET);
/* ilit 8 , 0 */
  REF(8).value.integer = 0;
  REF(8).tsdr = & dr_integer;
/* branch , 90 */
   goto c90;
c73:
/* noop */
  
/* notequal . 8 =(1) , 79 */
  if ( REF(8).value.integer != 1 ) goto c79;
/* ilit 8 , 0 */
  REF(8).value.integer = 0;
  REF(8).tsdr = & dr_integer;
/* branch , 90 */
   goto c90;
c79:
/* ordenum_lit 19 , 47 */
  REF(19).value.ord_enum = 47;
  REF(19).tsdr = & dr_ord_enumeration;
/* insert 3.2 19 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2),DEF(19),FALSE,0)) != Normal)
     goto ch_raise_exception;
c81:
/* noop */
  
/* ile . 8 =(0) , 90 */
  if ( REF(8).value.integer <= 0 ) goto c90;
/* ordenum_lit 20 , 46 */
  REF(20).value.ord_enum = 46;
  REF(20).tsdr = & dr_ord_enumeration;
/* insert 3.2 20 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2),DEF(20),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* isubtract 8 8 =(1) */
  if (!chf_isubtract(DEF(8),REF(8).value.integer,1)) goto ch_depletion;
/* branch , 81 */
   goto c81;
c90:
/* discard 15 */
  (*(REF(15).tsdr)->finalize)(REF(15).value,F_DISCARD,sched);
  REF(15).tsdr = & dr_bottom;
c91:
/* boolean 9 , TRUE */
  REF(9).value.boolean = TRUE;
  REF(9).tsdr = & dr_boolean;
/* branch , 28 */
   goto c28;
c94:
/* noop */
  
/* notequal . 11 =(46) , 105 */
  if ( REF(11).value.ord_enum != 46 ) goto c105;
/* branch_false 9 , 102 */
  if ( !REF(9).value.boolean ) goto c102;
/* iadd 8 8 =(1) */
  if (!chf_iadd(DEF(8),REF(8).value.integer,1)) goto ch_depletion;
/* branch , 28 */
   goto c28;
c102:
/* ordenum_lit 21 , 46 */
  REF(21).value.ord_enum = 46;
  REF(21).tsdr = & dr_ord_enumeration;
/* insert 3.2 21 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2),DEF(21),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 28 */
   goto c28;
c105:
/* branch_false 9 , 119 */
  if ( !REF(9).value.boolean ) goto c119;
/* ordenum_lit 22 , 47 */
  REF(22).value.ord_enum = 47;
  REF(22).tsdr = & dr_ord_enumeration;
/* insert 3.2 22 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2),DEF(22),FALSE,0)) != Normal)
     goto ch_raise_exception;
c108:
/* noop */
  
/* ile . 8 =(0) , 117 */
  if ( REF(8).value.integer <= 0 ) goto c117;
/* ordenum_lit 23 , 46 */
  REF(23).value.ord_enum = 46;
  REF(23).tsdr = & dr_ord_enumeration;
/* insert 3.2 23 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2),DEF(23),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* isubtract 8 8 =(1) */
  if (!chf_isubtract(DEF(8),REF(8).value.integer,1)) goto ch_depletion;
/* branch , 108 */
   goto c108;
c117:
/* boolean 9 , FALSE */
  REF(9).value.boolean = FALSE;
  REF(9).tsdr = & dr_boolean;
c119:
/* copy 24 11 */
  REF(24) = REF(11);
/* insert 3.2 24 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2),DEF(24),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 28 */
   goto c28;
c122:
/* endget 11 10 */
  end_selector(DEF(11),DEF(10),sched,GET);
/* discard 10 */
  (*(REF(10).tsdr)->finalize)(REF(10).value,F_DISCARD,sched);
  REF(10).tsdr = & dr_bottom;
/* branch_false 9 , 182 */
  if ( !REF(9).value.boolean ) goto c182;
/* ilt . 8 =(3) , 140 */
  if ( REF(8).value.integer < 3 ) goto c140;
/* ordenum_lit 25 , 47 */
  REF(25).value.ord_enum = 47;
  REF(25).tsdr = & dr_ord_enumeration;
/* insert 3.2 25 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2),DEF(25),FALSE,0)) != Normal)
     goto ch_raise_exception;
c130:
/* noop */
  
/* ile . 8 =(0) , 182 */
  if ( REF(8).value.integer <= 0 ) goto c182;
/* ordenum_lit 26 , 46 */
  REF(26).value.ord_enum = 46;
  REF(26).tsdr = & dr_ord_enumeration;
/* insert 3.2 26 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2),DEF(26),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* isubtract 8 8 =(1) */
  if (!chf_isubtract(DEF(8),REF(8).value.integer,1)) goto ch_depletion;
/* branch , 130 */
   goto c130;
c140:
/* noop */
  
/* notequal . 8 =(2) , 175 */
  if ( REF(8).value.integer != 2 ) goto c175;
/* ilit 12 , -1 */
  REF(12).value.integer = -1;
  REF(12).tsdr = & dr_integer;
/* copy 27 3.2 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(2).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(27).tsdr)->finalize)(REF(27).value,F_DISCARD,sched);
  REF(27).value = ch_val;
  REF(27).tsdr = & dr_table;
/* initget 28 27 , 0,0 */
  (*(REF(28).tsdr)->finalize)(REF(28).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(28),DEF(27),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c147:
/* get_or_goto 28 27 , 154 */
  if ((ch_returncode = get_selected_object(DEF(28),DEF(27),sched)) != Normal)
     goto c154;
/* notequal . 28 =(47) , 147 */
  if ( REF(28).value.ord_enum != 47 ) goto c147;
/* position 12 28 */
  ch_frame = get_selector_frame(DEF(28),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(12).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(12).tsdr = &dr_integer;
/* branch , 147 */
   goto c147;
c154:
/* endget 28 27 */
  end_selector(DEF(28),DEF(27),sched,GET);
/* discard 27 */
  (*(REF(27).tsdr)->finalize)(REF(27).value,F_DISCARD,sched);
  REF(27).tsdr = & dr_bottom;
/* ige . 12 =(0) , 163 */
  if ( REF(12).value.integer >= 0 ) goto c163;
/* discard 3.2 */
  (*(REF(3)DOT(2).tsdr)->finalize)(REF(3)DOT(2).value,F_DISCARD,sched);
  REF(3)DOT(2).tsdr = & dr_bottom;
/* return_exception 3 , 2 */
  if (ch_caller = do_return(REF(3).value)) {
    raise_user(QUAL(2),ch_caller); 
    sched->wakeup_proc(sched,ch_caller);}
  else rem_return_exception(DEF(3),QUAL(2));
  REF(3).tsdr = & dr_bottom;
/* exit , 3 */
  ch_e = handler_type__exit; ch_val = QUAL(3); goto ch_exception;
c163:
/* new_table 15 , 4 */
  if ((ch_returncode = che_new_table(DEF(15),QUAL(4),sched)) != Normal) 
     goto ch_raise_exception;
/* privatize 3.2 */
  if (REF(3)DOT(2).value.table->refcount != 1)
    if ((ch_returncode = doCopyOnWrite(DEF(3)DOT(2))) != Normal)
       goto ch_raise_exception;
/* initget 29 3.2 , 0,0 */
  (*(REF(29).tsdr)->finalize)(REF(29).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(29),DEF(3)DOT(2),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c166:
/* get_or_goto 29 3.2 , 173 */
  if ((ch_returncode = get_selected_object(DEF(29),DEF(3)DOT(2)
    ,sched)) != Normal) goto c173;
/* position 30 29 */
  ch_frame = get_selector_frame(DEF(29),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(30).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(30).tsdr = &dr_integer;
/* ilt . 30 12 , 166 */
  if ( REF(30).value.integer < REF(12).value.integer ) goto c166;
/* remove 31 29 3.2 */
  if ((ch_returncode = che_remove(DEF(31),DEF(29),DEF(3)DOT(2)
    ,sched)) != Normal) goto ch_raise_exception;
/* insert 15 31 */
  if ((ch_returncode = insertfunc(DEF(15),DEF(31),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 166 */
   goto c166;
c173:
/* endget 29 3.2 */
  end_selector(DEF(29),DEF(3)DOT(2),sched,GET);
/* branch , 181 */
   goto c181;
c175:
/* noop */
  
/* notequal . 8 =(1) , 179 */
  if ( REF(8).value.integer != 1 ) goto c179;
/* branch , 181 */
   goto c181;
c179:
/* ordenum_lit 32 , 47 */
  REF(32).value.ord_enum = 47;
  REF(32).tsdr = & dr_ord_enumeration;
/* insert 3.2 32 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(2),DEF(32),FALSE,0)) != Normal)
     goto ch_raise_exception;
c181:
/* discard 15 */
  (*(REF(15).tsdr)->finalize)(REF(15).value,F_DISCARD,sched);
  REF(15).tsdr = & dr_bottom;
c182:
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 186 */
   goto c186;
c185:
/* discard 7 */
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).tsdr = & dr_bottom;
c186:
/* discard 7 */
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c189:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
